/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *   qimsys                                                                  *
 *   Copyright (C) 2010 by Tasuku Suzuki <stasuku@gmail.com>                 *
 *                                                                           *
 *   This program is free software; you can redistribute it and/or modify    *
 *   it under the terms of the GNU General Lesser Public License as          *
 *   published by the Free Software Foundation; either version 2 of the      *
 *   License, or (at your option) any later version.                         *
 *                                                                           *
 *   This program is distributed in the hope that it will be useful,         *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           *
 *   GNU Lesser General Public License for more details.                     *
 *                                                                           *
 *   You should have received a copy of the GNU Lesser General Public        *
 *   License along with this program; if not, write to the                   *
 *   Free Software Foundation, Inc.,                                         *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.               *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#ifndef QT4IMMODULE_H
#define QT4IMMODULE_H

#include <QInputContext>

class Qt4IMModule : public QInputContext
{
    Q_OBJECT
    Q_DISABLE_COPY(Qt4IMModule)
public:
    explicit Qt4IMModule(QObject *parent = 0);
    ~Qt4IMModule();

    bool filterEvent(const QEvent *event);
    QFont font() const;
    QString identifierName();
    bool isComposing() const;
    QString language();
    void update();
    void reset();

    void setFocusWidget(QWidget *w);
    void widgetDestroyed(QWidget *w);

    bool available() const;

private:
    class Private;
    Private *d;
};

#endif//QT4IMMODULE_H
