/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *   qimsys                                                                  *
 *   Copyright (C) 2010 by Tasuku Suzuki <stasuku@gmail.com>                 *
 *                                                                           *
 *   This program is free software; you can redistribute it and/or modify    *
 *   it under the terms of the GNU General Lesser Public License as          *
 *   published by the Free Software Foundation; either version 2 of the      *
 *   License, or (at your option) any later version.                         *
 *                                                                           *
 *   This program is distributed in the hope that it will be useful,         *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           *
 *   GNU Lesser General Public License for more details.                     *
 *                                                                           *
 *   You should have received a copy of the GNU Lesser General Public        *
 *   License along with this program; if not, write to the                   *
 *   Free Software Foundation, Inc.,                                         *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.               *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#ifndef N900_H
#define N900_H

#include <QWidget>

class QimsysAbstractPluginObject;

class N900 : public QWidget
{
    Q_OBJECT
public:
    enum State {
        NotAvailable,
        Input,
        System,
    };
    Q_PROPERTY(State state READ state WRITE setState NOTIFY stateChanged)
    Q_ENUMS(State)

    N900(QimsysAbstractPluginObject *plugin, QWidget *parent = 0);
    ~N900();

    N900::State state() const;

public slots:
    void settingsUpdated();
    void setState(N900::State state);

signals:
    void stateChanged(N900::State state);

protected:
    bool event(QEvent *e);
    void showEvent(QShowEvent *);
    void hideEvent(QHideEvent *);
    void moveEvent(QMoveEvent *);

private:
    class Private;
    Private *d;
};

#endif//N900_H
